/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package org.dicom;

import java.awt.image.BufferedImage;
import java.awt.image.ColorModel;
import java.io.File;
import java.io.IOException;
import java.util.Iterator;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.imageio.ImageIO;

import javax.imageio.ImageReader;
import javax.imageio.ImageWriteParam;
import javax.imageio.ImageWriter;

import javax.imageio.stream.ImageInputStream;
import javax.imageio.stream.ImageOutputStream;

import org.dcm4che3.image.PaletteColorModel;
import org.dcm4che3.imageio.plugins.dcm.DicomImageReadParam;

/**
 * Convertion DICOM 3.0 vers jpeg
 * @author Dimitri
 */
public class Dcm2jpg {
    
     
   
    private final ImageReader imageReader =
            ImageIO.getImageReadersByFormatName("DICOM").next();
      
    public int n = 0; 
    private Boolean finish = false; 
    
    
    	/**
         * public static void main (String args []) throws IOException{
         JFileChooser choix = new JFileChooser();
	 choix.setFileSelectionMode(JFileChooser.FILES_ONLY);//sélectionne que le répertoire
         Dcm2jpg jpg = new Dcm2jpg(); 
         
         
        int retour = choix.showOpenDialog(null);
	 if(retour == JFileChooser.APPROVE_OPTION){
				    
		File fileInput = choix.getSelectedFile();
		JFileChooser saveDicom = new JFileChooser();
                saveDicom.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
		saveDicom.setMultiSelectionEnabled(false);
		saveDicom.showSaveDialog(null);
		File fileOutput =saveDicom.getSelectedFile();
               
		jpg.Dcm2jpg(fileInput,fileOutput);
		
	
	}
        
         * @param inputFile : input File
         * @param outputFile : output File
         * @throws IOException 
         */
public void Dcm2jpg(File inputFile, File outputFile) throws IOException{
		
         
     outputFile.mkdirs();//give new folder 
      
    n= this.setNumber(inputFile);
    
    
    if (n == 0){
          File destFinal = new File(outputFile+ "\\"+ inputFile.getName()+ ".jpg"); 
        convert(inputFile, destFinal, 0);
        
    }
    else {
 
    
		for(int i=0; i<=n-1;i++){
                       
    File outputFile2 = new File(outputFile + "\\" +inputFile.getName()); 
                    outputFile2.mkdirs();
                File destFinal2 = new File( outputFile2 + "\\"+ "("+ "frame"+ i +")" + ".jpg"); 
             
			convert(inputFile, destFinal2, i);
			
		}
                setFinish(true);
	}
}


   /**
	 *   Conversion un répertoire dicom vers jpeg2000/Conversion folder picture dicom to jpeg2000
	 *	- Donne nouveau chemin pour le répertoire / To give new path to folder
	 *  - Donne le nom du répertoire et les fichiers converties vont être dans ce nouveau répertoire
	 *  To give name folder and convertion files will find this new folder		
	 * 
	 * Exemple synthaxe/ Example :
	 
         * public static void main (String args []) throws IOException{
         JFileChooser choix = new JFileChooser();
	 choix.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);//sélectionne que le répertoire
         Dcm2jpg jpg = new Dcm2jpg(); 
         
         
        int retour = choix.showOpenDialog(null);
	 if(retour == JFileChooser.APPROVE_OPTION){
				    
		File fileInput = choix.getSelectedFile();
		JFileChooser saveDicom = new JFileChooser();
                saveDicom.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
		saveDicom.setMultiSelectionEnabled(false);
		saveDicom.showSaveDialog(null);
		File fileOutput =saveDicom.getSelectedFile();
               
		jpg.Dcm2jpg2(fileInput,fileOutput);
		
	
	}
         
         * @param inputFile : input File
         * @param outputFile : output File
         * @throws IOException
         * 
         * 
        * */

public void Dcm2jpg2(File inputFile, File outputFile) {						
		
    
    n = numberFile(inputFile);
		for(int i = 0; i<=n-2; i++){
                    
                   System.out.println(i);
		 File fileInput2; 
        try {
            fileInput2 = listFolder(inputFile,i);
            
            
                if(setNumber(fileInput2) == 1){
                
                File destFinal = new File(outputFile+ "\\"+fileInput2.getName()+ ".jpg");
                
                convert(fileInput2,destFinal,0);
                   
            }
               
            else {
                
                								
                // outputFolder.mkdirs();//give new folder
                
                this.Dcm2jpg(fileInput2, outputFile); 
                
            }
     setFinish(true);
        } catch (IOException ex) {
            Logger.getLogger(Dcm2jpg.class.getName()).log(Level.SEVERE, null, ex);
        }
                 outputFile.mkdirs();//give new folder 
                
}
}





    
    /**
     * Permit of converter in jpeg
     * @param src : input File
     * @param dest : ouput File
     * @param value : number of Frame(s)
     * @throws IOException 
     */
    public void convert(File src, File dest, int value) throws IOException{
                        BufferedImage bi = chargeImageDicomBufferise(src,value);
            bi = convert(bi);
            //dest.delete();
    
             
            
            ImageOutputStream ios = ImageIO.createImageOutputStream(dest);
            try {
                writeImage( bi,dest );
            } finally {
                try { ios.close(); }
                catch (IOException ignore) {}
            }
      
        
        
    }
    
     private BufferedImage convert(BufferedImage bi) {
        ColorModel cm = bi.getColorModel();
        if (cm instanceof PaletteColorModel)
            return ((PaletteColorModel) cm).convertToIntDiscrete(bi.getData());
        return bi;
    }

 
     
        /**
         * Building BufferingImage 
         * @param file : input file
         * @param value : number frame 
         * @return
         * @throws IOException 
         */
        
        public BufferedImage chargeImageDicomBufferise(File file, int value) throws IOException  {

		  	  Iterator<ImageReader> iter = ImageIO.getImageReadersByFormatName("DICOM");//spécifie l'image                      

		  	ImageReader readers = iter.next();//on se déplace dans l'image dicom

		 DicomImageReadParam   param1 =  (DicomImageReadParam) readers.getDefaultReadParam();//return DicomImageReadParam
		       //	Adjust the values of Rows and Columns in it and add a Pixel Data attribute with the byte array from the DataBuffer of the scaled Raster

		  	  ImageInputStream iis = ImageIO.createImageInputStream(file);

		     readers.setInput(iis, false);//sets the input source to use the given ImageInputSteam or other  Object

		  	 BufferedImage image = readers.read(value,param1);//BufferedImage image = reader.read(frameNumber, param); frameNumber = int qui est l'imageIndex
		  	  System.out.println(image);//affichage au terminal des caractères de l'image

		  	  readers.dispose();//Releases all of the native sreen resources used by this Window, its subcomponents, and all of its owned children
		  	return  image;

		    }
    
    	 /**
 *  Find number frame 
 * @param file : input file
 * @return numbre frame in Dicom
 * @throws IOException
 */
   public int setNumber(File file) throws IOException  {

		    /* Parcourt le fichier dicom*/
	  	   Iterator<ImageReader> iter = ImageIO.getImageReadersByFormatName("DICOM");//spécifie l'image
	       ImageReader readers = (ImageReader)iter.next();//on se déplace dans l'image dicom

	        DicomImageReadParam   param1=  (DicomImageReadParam) readers.getDefaultReadParam();//return DicomImageReadParam
	       //	Adjust the values of Rows and Columns in it and add a Pixel Data attribute with the byte array from the DataBuffer of the scaled Raster

	  	  ImageInputStream iis = ImageIO.createImageInputStream(file);//création du fichier image


	       readers.setInput(iis, false);//sets the input source to use the given ImageInputSteam or other  Object

	        //iis.close();
            int  number = readers.getNumImages(true);//numberOfFrame on a "readers" qui doit être DicomImage
	        System.out.println(number);//return NumberOfFrame (Tag : (0028, 0008))
	       return  number;
	    }
    
    
    
    
   //Calcul le nombre fichier dans le repertoire / Calculate numbers files in a folder 
public static int numberFile (File folder){
	int nb = 0 ;
	 if ( folder.isDirectory ( ) ) {

	                File[] list = folder.listFiles();
	                if (list != null){               
	                	 nb = list.length;
	                	 return nb;

	                } else {
	                	System.err.println(folder + " : Erreur de lecture.");

	                }
	        }
	return nb;
} 
    
    
  /**
 * Donne chaque fichier d'un répertoire/Giving files in folder
 * @param folder : Input Folder
 * @param i : number of file in Folder
 * @return
 */
public File listFolder (File folder, int i)  throws IOException{
	System.out.println(folder.getAbsolutePath());
	File fileOutput =null;
	
	if(folder.isDirectory()){
		File[] list = folder.listFiles();
		if (list != null){
			
			fileOutput = list[i];
			return fileOutput;
			
		}else {
			System.err.println(folder + "error");
			}
	}
	return fileOutput;
  
}


/**
 * Donne la liste des fichiers répertoires/List file 
 * @param folder : Folder input
 * @return
 */
public File[] listeRepertoire2 (File folder){
	System.out.println(folder.getAbsolutePath());
	if(folder.isDirectory()){
		File[] list = folder.listFiles();
		return list;
	}
	return null;
}
        
/**
 * Create file jpeg
 * @param bi : BufferedImage input
 * @param outputFile : File output
 * @throws IOException 
 */  
    private void writeImage(BufferedImage bi, File outputFile )
            throws IOException {
        
        ImageIO.write(bi, "jpg", outputFile);
    }

    public void setFinish(Boolean finish){
        this.finish = finish; 
           
        
    }
    
    public Boolean getFinish(){
        return finish;    
    }
    
}
