/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package org.dicom;

import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.RenderingHints;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;
import java.awt.image.Raster;
import java.awt.image.SampleModel;
import java.io.File;
import java.io.IOException;
import java.util.Iterator;
import javax.imageio.ImageIO;
import javax.imageio.ImageReadParam;

import javax.imageio.ImageReader;
import javax.imageio.stream.FileImageInputStream;



import javax.imageio.stream.ImageInputStream;
import org.dcm4che3.imageio.plugins.dcm.DicomImageReadParam;
import org.dcm4che3.imageio.plugins.dcm.DicomImageReader;


/**
 *  Class raster, bufferedImage for dicom 
 * @author Dimitri
 */
public class DicomBuffered {
    
       private Raster myImage;
    
        
          private BufferedImage buf;
       /**
         * Building BufferingImage and displays overlays or without overlays 
         * @param file : input file
         * @param value : number frame 
         * @return
         * @throws IOException 
         */       
        public BufferedImage chargeImageDicomBufferise(File file, int value) throws IOException  {
  Iterator<ImageReader> iter = ImageIO.getImageReadersByFormatName("DICOM");//spécifie l'image

                                                        

		  	ImageReader readers = iter.next();//on se déplace dans l'image dicom

		 DicomImageReadParam   param1 =  (DicomImageReadParam) readers.getDefaultReadParam();//return DicomImageReadParam
		       //	Adjust the values of Rows and Columns in it and add a Pixel Data attribute with the byte array from the DataBuffer of the scaled Raster

		  	  ImageInputStream iis = ImageIO.createImageInputStream(file);

		     readers.setInput(iis, false);//sets the input source to use the given ImageInputSteam or other  Object

		     
		  	 BufferedImage image = readers.read(value,param1);//BufferedImage image = reader.read(frameNumber, param); frameNumber = int qui est l'imageIndex
		  	  System.out.println(image);//affichage au terminal des caractères de l'image

		  	  readers.dispose();//Releases all of the native sreen resources used by this Window, its subcomponents, and all of its owned children
		  	return  image;

		    }
          
    /**
     * Raster of Dicom
     * @param file : input file
     * @param indice : number of Frame
     * @return
     * @throws IOException 
     */
    public Raster rasterPicture(File file, int indice) throws IOException{

		//open file pixel
		  Iterator<ImageReader> iter = ImageIO.getImageReadersByFormatName("DICOM");//"MIME"

	  	  DicomImageReader readers = (DicomImageReader)iter.next();//next pixel

	          DicomImageReadParam  param =  (DicomImageReadParam) readers.getDefaultReadParam();//return DicomImageReadParam
	       //	Adjust the values of Rows and Columns in it and add a Pixel Data attribute with the byte array from the DataBuffer of the scaled Raster

                                
	  	  ImageInputStream iis = ImageIO.createImageInputStream(file);

	          readers.setInput(iis, true);//sets the input source to use the given ImageInputSteam or other  Object
	      //Lu les pixels

	          Raster myImage = readers.readRaster(indice, param);  //Read raster
                  
	          System.out.print(myImage);// display picture


	    return this.setMyImage(myImage);
	}
    
    /**
	 * Put raster
	 * @param myImage
	 * @return un nouveau raster
	 */
	public Raster setMyImage(Raster myImage) {
		this.myImage = myImage;
		return myImage;
	}

	/**
	 *Return raster image fileInput
	 * @return raster (largueur, hauteur... )
	 */
	public Raster getMyImage() {
		return myImage;
	}


     /**
 *  Find number frame 
 * @param file : input file
 * @return numbre frame in Dicom
 * @throws IOException
 */
   public int setNumberFrame(File file) throws IOException  {

		
	  	   Iterator<ImageReader> iter = ImageIO.getImageReadersByFormatName("DICOM");
	       ImageReader readers = (ImageReader)iter.next();

	        DicomImageReadParam   param1=  (DicomImageReadParam) readers.getDefaultReadParam();//return DicomImageReadParam
	       //	Adjust the values of Rows and Columns in it and add a Pixel Data attribute with the byte array from the DataBuffer of the scaled Raster

	  	  ImageInputStream iis = ImageIO.createImageInputStream(file);//création du fichier image


	       readers.setInput(iis, false);//sets the input source to use the given ImageInputSteam or other  Object

	        //iis.close();
            int  number = readers.getNumImages(false);//numberOfFrame on a "readers" qui doit être DicomImage
	        System.out.println(number);//return NumberOfFrame (Tag : (0028, 0008))
	       return  number;
	    }
   
   
   /**
 * Compined two bufferedImages
 * @param image1
 * @param image2
 * @return
 */
public static BufferedImage addImage(BufferedImage image1, BufferedImage image2){
	Graphics2D g2d = image1.createGraphics();
	g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
	RenderingHints.VALUE_ANTIALIAS_ON);
	g2d.setRenderingHint(RenderingHints.KEY_ALPHA_INTERPOLATION,
	RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
	g2d.drawImage(image2, 0, 0, null);
	g2d.dispose();
	return image1 ;
	}

   
public Image bufferedImagetoImage(BufferedImage bi) {
    return Toolkit.getDefaultToolkit().createImage(bi.getSource());
}



public void setBuffered(BufferedImage buf){
    
    this.buf = buf; 
    
}


public BufferedImage getBuffered(){
    return buf; 
}

}
