package tablePixel;

import ihmdicom.*;
import java.awt.Component;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JTable;
import javax.swing.ListCellRenderer;
import javax.swing.UIManager;
import javax.swing.table.JTableHeader;

/**
 * Classe permettant d'utiliser un JLabel comme ListCellRenderer afin de
 * donner au header de lignes le même style du header de colonne
 * @author Bilal
 * source: http://www.java2s.com/Code/Java/Swing-Components/TableRowHeaderExample.htm
 */
public class RowHeaderRenderer extends JLabel implements ListCellRenderer {

    public RowHeaderRenderer(JTable table) {
         table.getColumnModel().getColumn(0).setPreferredWidth(28);
        JTableHeader header = table.getTableHeader();
       
        setOpaque(true);
        setBorder(UIManager.getBorder("TableHeader.cellBorder"));
        setHorizontalAlignment(CENTER);
        setForeground(header.getForeground());
        setBackground(header.getBackground());
        setFont(header.getFont());
    }

    public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
        setText((value == null) ? "" : value.toString());
        return this;
    }
}
